PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package serverobject
  Definition Classes
    objects
-  package turret
  Definition Classes
    serverobject
- FacilityTurret
- FacilityTurretControl
- FacilityTurretDefinition
- TurretAmmoBox
- TurretDefinition
- TurretUpgrade
- TurretWeapon
- WeaponTurret
- WeaponTurrets

c

net.psforever.objects.serverobject.turret

# FacilityTurretControl

###

#### class FacilityTurretControl extends PoweredAmenityControl with Check with MountableBehavior with DamageableWeaponTurret with RepairableWeaponTurret with AmenityAutoRepair with JammableMountedWeapons with CaptureTerminalAwareBehavior

An `Actor` that handles messages being dispatched to a specific `MannedTurret`.
Mounted turrets have only slightly different entry requirements than a normal vehicle because they encompass both faction-specific facility turrets and faction-blind cavern sentry turrets.

Source
  FacilityTurretControl.scala

Linear Supertypes
CaptureTerminalAwareBehavior, JammableMountedWeapons, JammableBehavior, AmenityAutoRepair, NtuStorageBehavior, RepairableWeaponTurret, RepairableEntity, Repairable, DamageableWeaponTurret, AggravatedBehavior, DamageableEntity, Damageable, MountableBehavior, Check, BasicAffinity, PoweredAmenityControl, Actor, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. FacilityTurretControl
2. CaptureTerminalAwareBehavior
3. JammableMountedWeapons
4. JammableBehavior
5. AmenityAutoRepair
6. NtuStorageBehavior
7. RepairableWeaponTurret
8. RepairableEntity
9. Repairable
10. DamageableWeaponTurret
11. AggravatedBehavior
12. DamageableEntity
13. Damageable
14. MountableBehavior
15. Check
16. BasicAffinity
17. PoweredAmenityControl
18. Actor
19. AnyRef
20. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new FacilityTurretControl(turret: FacilityTurret)

   turret

     the `MannedTurret` object being governed

### Type Members

1.  type Receive = PartialFunction[Any, Unit]
   Definition Classes
     Actor

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def AggravatedObject: Target with WeaponTurret
   Definition Classes
     DamageableWeaponTurret → AggravatedBehavior
5.  def AggravatedReaction: Boolean
   Definition Classes
     AggravatedBehavior
6.  def AggravationCleanup(id: Long): Unit
   Definition Classes
     AggravatedBehavior
7.  def AutoRepairObject: FacilityTurret
   Definition Classes
     FacilityTurretControl → AmenityAutoRepair
8.  def CanBeRepairedByNanoDispenser(player: Player, item: Tool): Unit

   Catch the expected repair message and apply further checks to the combination of the target, the equipment, and tis user.

   Catch the expected repair message and apply further checks to the combination of the target, the equipment, and tis user. If the checks pass, perform the repair.

   player

     the user of the nano dispenser tool

   item

     the nano dispenser tool

   Definition Classes
     RepairableEntity → Repairable
9.  def CanPerformRepairs(target: Target, player: Player, item: Tool): Boolean

   Test the combination of target entity, equipment user, and the equipment to determine if the repair process attempt would be permitted.

   Test the combination of target entity, equipment user, and the equipment to determine if the repair process attempt would be permitted. It is not necessary to check that the tool and its ammunition are correct types; that test was already performed.
   The target entity must be repairable and have less than full health and, if it is destroyed, must have an object attribute that permits it to be repaired after being destroyed.
   The user must have the same faction affinity as the target entity or be neutral.
   The equipment must have some ammunition.
   The user must be alive and be within a certain distance of the target entity.

   target

     the entity being repaired

   player

     the user of the nano dispenser tool

   item

     the nano dispenser tool

   returns

     `true`, if the target entity can be repaired; `false`, otherwise

   Attributes
     protected
   Definition Classes
     RepairableEntity
   See also

     `org.log4s.getLogger`

     `PlanetSideEmpire`

     `Vector3.Distance`

     `VitalityDefinition`

10.  def CancelJammeredSound(target: Any): Unit

    Deactivate a distinctive buzzing sound effect.

    Deactivate a distinctive buzzing sound effect. Due to considerations of the object that is the target, this is left to be implemented by a subclass. We merely stop the timer.

    target

      an object that can be affected by the jammered status

    Definition Classes
      JammableMountedWeapons → JammableBehavior
11.  def CancelJammeredStatus(target: Any): Unit

    Deactivate the effects of the jammered status.

    Deactivate the effects of the jammered status. Due to considerations of the object that is the target, this is left to be implemented by a subclass. We merely stop the timer.

    target

      an object that can be affected by the jammered status

    Definition Classes
      JammableMountedWeapons → JammableBehavior
12.  def CaptureTerminalAwareObject: FacilityTurret
    Definition Classes
      FacilityTurretControl → CaptureTerminalAwareBehavior
13.  def CleanupAggravationTimer(id: Long): Unit
    Definition Classes
      AggravatedBehavior
14.  def DamageAwareness(target: Target, cause: DamageResult, amount: Any): Unit

    What happens when damage is sustained but the target does not get destroyed.

    What happens when damage is sustained but the target does not get destroyed.

    target

      the entity being damaged

    cause

      historical information about the damage

    amount

      the amount of damage

    Attributes
      protected
    Definition Classes
      FacilityTurretControl → DamageableWeaponTurret → DamageableEntity
15.  def DamageLog(target: Target, msg: String): Unit

    Log a damage message with a decorator for this target.

    Log a damage message with a decorator for this target. The decorator is constructed by the `Actor` name of the entity, sliced after the last forward/slash. For example, for "foo/bar/name", the decorator is just "name".

    target

      the entity to be used for the decorator

    msg

      the message for the damage log

    Attributes
      protected
    Definition Classes
      DamageableEntity
    See also

      `PlanetSideServerObject`

16.  def DamageLog(msg: String): Unit

    Log a damage message.

    Log a damage message.

    msg

      the message for the damage log

    Attributes
      protected
    Definition Classes
      DamageableEntity
17.  def DamageableObject: FacilityTurret

    Contextual access to the object being the target of this damage.

    Contextual access to the object being the target of this damage. Needs declaration in lowest implementing code.

    returns

      the entity controlled by this actor

    Definition Classes
      FacilityTurretControl → DamageableWeaponTurret → Damageable
18.  def DestructionAwareness(target: Target, cause: DamageResult): Unit

    What happens when the target sustains too much damage and is destroyed.

    What happens when the target sustains too much damage and is destroyed.

    target

      the entity being destroyed

    cause

      historical information about the damage

    Attributes
      protected
    Definition Classes
      FacilityTurretControl → DamageableWeaponTurret → DamageableEntity
    See also

      `Damageable.DestructionAwareness`

19.  def EndAllAggravation(): Unit
    Definition Classes
      AggravatedBehavior
20.  def FactionObject: FacilityTurret
    Definition Classes
      FacilityTurretControl → BasicAffinity
21.  def HandleDamage(target: Target, cause: DamageResult, damage: Any): Unit

    Select between mere damage reception or target destruction.

    Select between mere damage reception or target destruction.

    target

      the entity being damaged

    cause

      historical information about the damage

    damage

      the amount of damage

    Attributes
      protected
    Definition Classes
      DamageableEntity
    See also

      `VitalDefinition.DamageDestroysAt`

22.  def HandleNtuGrant(sender: ActorRef, src: NtuContainer, amount: Float): Unit

    When reports of an NTU provision is returned to the requesting amenity, the amount of repair that can be performed is obtained and, if the amenity still requires those repairs, auto-repair executes a single tick.

    When reports of an NTU provision is returned to the requesting amenity, the amount of repair that can be performed is obtained and, if the amenity still requires those repairs, auto-repair executes a single tick.

    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
    See also

      `RepairableAmenity`

23.  def HandleNtuOffer(sender: ActorRef, src: NtuContainer): Unit
    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
24.  def HandleNtuRequest(sender: ActorRef, min: Float, max: Float): Unit
    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
25.  def JammableObject: FacilityTurret

    `ZoneAware` is used for callback to the event systems

    `ZoneAware` is used for callback to the event systems

    Definition Classes
      FacilityTurretControl → JammableBehavior
26.  def MountableObject: FacilityTurret
    Definition Classes
      FacilityTurretControl → MountableBehavior
27.  def NtuStorageObject: NtuContainer
    Definition Classes
      NtuStorageBehavior
28.  def PerformDamage(target: Target, applyDamageTo: Output): Unit

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed.

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed. By default, only take an interest in the change of "health". If implementing custom `DamageableAmenity` with no new message handling, choose to override this method.

    target

      the entity to be damaged

    applyDamageTo

      the function that applies the damage to the target in a target-tailored fashion

    Attributes
      protected
    Definition Classes
      DamageableEntity → Damageable
    See also

      `DamageableAmenity.TakesDamage`

      `ResolutionCalculations.Output`

      `Vitality.Health`

29.  def PerformRepairs(target: Target, amount: Int): Int
    Definition Classes
      FacilityTurretControl → RepairableEntity
30.  def PerformRepairs(target: Target, player: Player, item: Tool): Unit

    Calculate the health points change and enact that repair action if the targets are stationary.

    Calculate the health points change and enact that repair action if the targets are stationary. Restore the target entity to a not destroyed state if applicable. Always show the repair progress bar window by using the appropriate packet.

    target

      the entity being repaired

    player

      the user of the nano dispenser tool

    item

      the nano dispenser tool

    Attributes
      protected
    Definition Classes
      RepairableEntity
    See also

      `AvatarAction.PlanetsideAttributeToAll`

      `AvatarAction.SendResponse`

      `AvatarService`

      `InventoryStateMessage`

      `PlanetSideGameObject.isMoving`

      `RepairMessage`

      `Service.defaultPlayerGUID`

      `Tool.Discharge`

      `Zone.AvatarEvents`

31.  def RemoveAggravatedEntry(id: Long): Aura
    Definition Classes
      AggravatedBehavior
32.  def RepairValue(item: Tool): Int

    The amount of repair that any specific tool provides.

    The amount of repair that any specific tool provides.

    item

      the tool in question

    returns

      an amount to add to the repair attempt progress

    Definition Classes
      RepairableEntity → Repairable
    See also

      `Repairable.Quality`

33.  def RepairableObject: FacilityTurret

    Contextual access to the object being the target of this damage.

    Contextual access to the object being the target of this damage. Needs declaration in lowest implementing code.

    returns

      the entity controlled by this actor

    Definition Classes
      FacilityTurretControl → RepairableWeaponTurret → Repairable
34.  def Restoration(obj: Target): Unit

    The entity is no longer destroyed.

    The entity is no longer destroyed.

    obj

      the entity

    Definition Classes
      FacilityTurretControl → RepairableWeaponTurret → Repairable
35.  def StartJammeredSound(target: Any, dur: Int): Unit

    Activate a distinctive buzzing sound effect.

    Activate a distinctive buzzing sound effect. Due to considerations of the object that is the target, this is left to be implemented by a subclass. We merely start the timer.

    target

      an object that can be affected by the jammered status

    dur

      the duration of the timer, in milliseconds; by default, 30000

    Definition Classes
      JammableMountedWeapons → JammableBehavior
36.  def StartJammeredStatus(target: Any, dur: Int): Unit

    Deactivate the effects of the jammered status.

    Deactivate the effects of the jammered status. Due to considerations of the object that is the target, this is left to be implemented by a subclass. We merely stop the timer.

    target

      an object that can be affected by the jammered status

    dur

      the duration of the timer, in milliseconds

    Definition Classes
      JammableMountedWeapons → JammableBehavior
37.  def StopNtuBehavior(sender: ActorRef): Unit

    Stop the auto-repair timer.

    Stop the auto-repair timer.

    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
38.  def TryAggravationEffectActivate(data: DamageResult): Option[AggravatedDamage]
    Definition Classes
      AggravatedBehavior
39.  def TryJammerEffectActivate(target: Any, cause: DamageResult): Unit

    If the target can be validated against, affect it with the jammered status.

    If the target can be validated against, affect it with the jammered status.

    target

      the objects to be determined if affected by the source's jammering

    cause

      the source of the "jammered" status

    Definition Classes
      JammableBehavior
40.  def WillAffectTarget(target: Target, damage: Int, cause: DamageResult): Boolean

    Does the damage or the projectile that caused the damage offer any reason to execute the reminder of damage resolution considerations? The projectile causing additional affects, e.g., jamming, should be tested here, when applicable.

    Does the damage or the projectile that caused the damage offer any reason to execute the reminder of damage resolution considerations? The projectile causing additional affects, e.g., jamming, should be tested here, when applicable. Contrast with `Vitality.CanDamage`. The damage value tested against should be the total value of all meaningful vital statistics affected.

    target

      the entity to be damaged

    damage

      the amount of damage

    cause

      historical information about the damage

    returns

      `true`, if damage resolution is to be evaluated; `false`, otherwise

    Attributes
      protected
    Definition Classes
      DamageableEntity
    See also

      `Damageable.CanDamageOrJammer`

      `PerformDamage`

41.  final def actuallyTryAutoRepair(): Boolean

    Attempt to start auto-repair operation only if no operation is currently being processed.

    Attempt to start auto-repair operation only if no operation is currently being processed. In case that an override to the normals operations of `tryAutoRepair` is necessary, but the superclass can not be invoked, this method is the backup of those operations to initiate auto-repair.

    returns

      `true`, if the auto-repair process started specifically due to this call; `false`, if it was already started, or did not start

    Definition Classes
      AmenityAutoRepair
    See also

      `tryAutoRepair`

42.  val aggravatedBehavior: Receive
    Definition Classes
      AggravatedBehavior
43.  def aroundPostRestart(reason: Throwable): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
44.  def aroundPostStop(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
45.  def aroundPreRestart(reason: Throwable, message: Option[Any]): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
46.  def aroundPreStart(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
47.  def aroundReceive(receive: akka.actor.Actor.Receive, msg: Any): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
48.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
49.  final val autoRepairBehavior: Receive
    Definition Classes
      AmenityAutoRepair
50.  final val canBeRepairedByNanoDispenser: akka.actor.Actor.Receive

    The official mixin hook; `orElse` onto the "control" `Actor` `receive`; catch the expected repair message and apply initial checks to the item

    The official mixin hook; `orElse` onto the "control" `Actor` `receive`; catch the expected repair message and apply initial checks to the item

    Definition Classes
      Repairable
    See also

      `Ammo`

      `CanBeRepairedByNanoDispenser`

      `CommonMessages.Use`

      `GlobalDefinitions`

      `Tool.AmmoType`

51.  val captureTerminalAwareBehaviour: akka.actor.Actor.Receive
    Definition Classes
      CaptureTerminalAwareBehavior
52.  val checkBehavior: Receive
    Definition Classes
      Check
53.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
54.  def commonBehavior: Receive
55.  implicit val context: ActorContext
    Definition Classes
      Actor
56.  def damageableWeaponTurretPostStop(): Unit
    Definition Classes
      DamageableWeaponTurret
57.  val dismountBehavior: Receive

    The logic governing `Mountable` objects that use the `TryDismount` message.

    The logic governing `Mountable` objects that use the `TryDismount` message. This is a mix-in trait for combining with existing `Receive` logic.

    Definition Classes
      MountableBehavior
    See also

      `Seat`

      `Mountable`

58.  def dismountTest(obj: Mountable with WorldEntity, seatNumber: Int, user: Player): Boolean
    Attributes
      protected
    Definition Classes
      MountableBehavior
59.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
60.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
61.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
62.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
63.  def getUsedMountPoint(playerName: String, seatNumber: Int): Int
    Definition Classes
      MountableBehavior
64.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
65.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
66.  def isPowered: Boolean
    Definition Classes
      PoweredAmenityControl
67.  val jammableBehavior: Receive
    Definition Classes
      JammableBehavior
68.  val jammedSound: Boolean

    flag for jammed sound

    flag for jammed sound

    Attributes
      protected
    Definition Classes
      JammableBehavior
69.  val jammeredSoundTimer: Cancellable

    the sound timer

    the sound timer

    Attributes
      protected
    Definition Classes
      JammableBehavior
70.  val jammeredStatusTimer: Cancellable

    the effect timer

    the effect timer

    Attributes
      protected
    Definition Classes
      JammableBehavior
71.  val mountBehavior: Receive

    The logic governing `Mountable` objects that use the `TryMount` message.

    The logic governing `Mountable` objects that use the `TryMount` message. This is a mix-in trait for combining with existing `Receive` logic.

    Definition Classes
      MountableBehavior
    See also

      `Seat`

      `Mountable`

72.  def mountTest(obj: PlanetSideServerObject with Mountable, seatNumber: Int, player: Player): Boolean
    Attributes
      protected
    Definition Classes
      FacilityTurretControl → MountableBehavior
73.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
74.  def noNtuSupplyCallback(): Unit

    No (further) provisions of NTU to the potential requesting amenity will be forthcoming.

    No (further) provisions of NTU to the potential requesting amenity will be forthcoming. Cancel any attempts at auto-repair.

    Definition Classes
      AmenityAutoRepair
75.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
76.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
77.  final val originalTakesDamage: akka.actor.Actor.Receive

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    Definition Classes
      Damageable
78.  def postRestart(reason: Throwable): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
79.  def postStop(): Unit
    Definition Classes
      FacilityTurretControl → Actor
80.  final def powerOffCondition: Receive
    Definition Classes
      PoweredAmenityControl
81.  final def powerOnCondition: Receive
    Definition Classes
      PoweredAmenityControl
82.  def powerTurnOffCallback(): Unit
    Definition Classes
      FacilityTurretControl → PoweredAmenityControl
83.  def powerTurnOnCallback(): Unit
    Definition Classes
      FacilityTurretControl → PoweredAmenityControl
84.  def poweredStateLogic: Receive
    Definition Classes
      FacilityTurretControl → PoweredAmenityControl
85.  def preRestart(reason: Throwable, message: Option[Any]): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
86.  def preStart(): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
87.  final def receive: Receive
    Definition Classes
      PoweredAmenityControl → Actor
88.  implicit final val self: ActorRef
    Definition Classes
      Actor
89.  final def sender(): ActorRef
    Definition Classes
      Actor
90.  final def stopAutoRepair(): Unit

    Cancel any attempts at auto-repair by stopping any currently processing repair timer The operation can be resumed.

    Cancel any attempts at auto-repair by stopping any currently processing repair timer The operation can be resumed.

    Definition Classes
      AmenityAutoRepair
    See also

      `stopAutoRepairFunctionality`

91.  def storageBehavior: Receive
    Definition Classes
      NtuStorageBehavior
92.  def supervisorStrategy: SupervisorStrategy
    Definition Classes
      Actor
93.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
94.  val takesDamage: Receive

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    Definition Classes
      DamageableWeaponTurret → Damageable
95.  def toString(): String
    Definition Classes
      AnyRef → Any
96.  def tryAutoRepair(): Boolean

    Attempt to start auto-repair operation only if no operation is currently being processed.

    Attempt to start auto-repair operation only if no operation is currently being processed.

    returns

      `true`, if the auto-repair process started specifically due to this call; `false`, if it was already started, or did not start

    Definition Classes
      FacilityTurretControl → AmenityAutoRepair
    See also

      `actuallyTryAutoRepair`

97.  def unhandled(message: Any): Unit
    Definition Classes
      Actor
98.  def unpoweredStateLogic: Receive
    Definition Classes
      FacilityTurretControl → PoweredAmenityControl
99.  val usedMountPoint: HashMap[String, Int]

    retain the mount point that was used by this occupant to mount

    retain the mount point that was used by this occupant to mount

    Definition Classes
      MountableBehavior
100.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
101.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
102.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException]) @native()
103.  var weaponAmmoRechargeTimer: Cancellable
104.  def withNtuSupplyCallback(): Unit

     Confirm that a provision of NTU to the potential requesting amenity is possible.

     Confirm that a provision of NTU to the potential requesting amenity is possible. Attempt to start auto-repair operations.

     Definition Classes
       AmenityAutoRepair

### Inherited from CaptureTerminalAwareBehavior

### Inherited from JammableMountedWeapons

### Inherited from JammableBehavior

### Inherited from AmenityAutoRepair

### Inherited from NtuStorageBehavior

### Inherited from RepairableWeaponTurret

### Inherited from RepairableEntity

### Inherited from Repairable

### Inherited from DamageableWeaponTurret

### Inherited from AggravatedBehavior

### Inherited from DamageableEntity

### Inherited from Damageable

### Inherited from MountableBehavior

### Inherited from Check

### Inherited from BasicAffinity

### Inherited from PoweredAmenityControl

### Inherited from Actor

### Inherited from AnyRef

### Inherited from Any

### Ungrouped